# Nut
# by Eresse <eresse@eresse.net>

# External Includes
require 'uri'
require 'cgi'
require 'rxio'

# Internal Includes
require 'nut/handler'

# Nut Module
module Nut

	# Service Class
	class Service < RxIO::Service

		# Defaults
		DEFAULT_ADDR = 'localhost'
		DEFAULT_PORT = 23280

		# Attribute Access
		attr_reader :request_handler

		# Construct:
		# Builds a *Service* set to listen for incoming connections @ _addr_ on _port_.
		# @param [String] addr
		# @param [Fixnum] port
		# @param [Hash] ssl_params
		# @param [Module] request_handler
		def initialize addr = DEFAULT_ADDR, port = DEFAULT_PORT, ssl_params = nil, request_handler

			# Super
			super addr, port, Handler, ssl_params

			# Set Request Handler
			@request_handler = request_handler
		end
	end
end
